searchNodes=[{"doc":"This module provides a functionality to open a session, execute a RTSP requests through that session and close the session.","ref":"Membrane.RTSP.html","title":"Membrane.RTSP","type":"module"},{"doc":"","ref":"Membrane.RTSP.html#announce/3","title":"Membrane.RTSP.announce/3","type":"function"},{"doc":"","ref":"Membrane.RTSP.html#describe/2","title":"Membrane.RTSP.describe/2","type":"function"},{"doc":"","ref":"Membrane.RTSP.html#get_parameter/3","title":"Membrane.RTSP.get_parameter/3","type":"function"},{"doc":"","ref":"Membrane.RTSP.html#options/2","title":"Membrane.RTSP.options/2","type":"function"},{"doc":"","ref":"Membrane.RTSP.html#pause/2","title":"Membrane.RTSP.pause/2","type":"function"},{"doc":"","ref":"Membrane.RTSP.html#play/2","title":"Membrane.RTSP.play/2","type":"function"},{"doc":"","ref":"Membrane.RTSP.html#record/2","title":"Membrane.RTSP.record/2","type":"function"},{"doc":"","ref":"Membrane.RTSP.html#set_parameter/3","title":"Membrane.RTSP.set_parameter/3","type":"function"},{"doc":"","ref":"Membrane.RTSP.html#setup/3","title":"Membrane.RTSP.setup/3","type":"function"},{"doc":"","ref":"Membrane.RTSP.html#teardown/2","title":"Membrane.RTSP.teardown/2","type":"function"},{"doc":"","ref":"Membrane.RTSP.html#t:headers/0","title":"Membrane.RTSP.headers/0","type":"type"},{"doc":"This module represents a RTSP 1.0 request.","ref":"Membrane.RTSP.Request.html","title":"Membrane.RTSP.Request","type":"module"},{"doc":"Returns the encoded URI as a binary. This is handy for digest auth since this value must be encoded as per the digest algorithm","ref":"Membrane.RTSP.Request.html#process_uri/2","title":"Membrane.RTSP.Request.process_uri/2","type":"function"},{"doc":"Renders the a RTSP request struct into a binary that is a valid RTSP request string that can be transmitted via communication channel.iex&gt; uri = URI.parse(&quot;rtsp://domain.net:554/path:movie.mov&quot;) iex&gt; Request.stringify(%Request{method: &quot;DESCRIBE&quot;}, uri) &quot;DESCRIBE rtsp://domain.net:554/path:movie.mov RTSP/1.0\\r\\n\\r\\n&quot; iex&gt; Request.stringify(%Request{method: &quot;PLAY&quot;, path: &quot;trackID=2&quot;}, uri) &quot;PLAY rtsp://domain.net:554/path:movie.mov/trackID=2 RTSP/1.0\\r\\n\\r\\n&quot; Access credentials won't be rendered into an url present in a RTSP start line.iex&gt; uri = URI.parse(&quot;rtsp://user:password@domain.net:554/path:movie.mov&quot;) iex&gt; Request.stringify(%Request{method: &quot;DESCRIBE&quot;}, uri) &quot;DESCRIBE rtsp://domain.net:554/path:movie.mov RTSP/1.0\\r\\n\\r\\n&quot;","ref":"Membrane.RTSP.Request.html#stringify/2","title":"Membrane.RTSP.Request.stringify/2","type":"function"},{"doc":"Attaches a header to a RTSP request struct. iex&gt; Request.with_header(%Request{method: &quot;DESCRIBE&quot;}, &quot;header_name&quot;, &quot;header_value&quot;) %Request{method: &quot;DESCRIBE&quot;, headers: [{&quot;header_name&quot;,&quot;header_value&quot;}]}","ref":"Membrane.RTSP.Request.html#with_header/3","title":"Membrane.RTSP.Request.with_header/3","type":"function"},{"doc":"","ref":"Membrane.RTSP.Request.html#t:t/0","title":"Membrane.RTSP.Request.t/0","type":"type"},{"doc":"This module represents a RTSP response.","ref":"Membrane.RTSP.Response.html","title":"Membrane.RTSP.Response","type":"module"},{"doc":"Retrieves the first header matching given name from a response. iex&gt; response = %Response{ ...&gt; status: 200, ...&gt; version: &quot;1.0&quot;, ...&gt; headers: [{&quot;header_name&quot;, &quot;header_value&quot;}] ...&gt; } iex&gt; Response.get_header(response, &quot;header_name&quot;) {:ok, &quot;header_value&quot;} iex&gt; Response.get_header(response, &quot;non_existent_header&quot;) {:error, :no_such_header}","ref":"Membrane.RTSP.Response.html#get_header/2","title":"Membrane.RTSP.Response.get_header/2","type":"function"},{"doc":"Parses RTSP response.If the body is present it will be parsed according to Content-Type header. Currently only the application/sdp is supported.","ref":"Membrane.RTSP.Response.html#parse/1","title":"Membrane.RTSP.Response.parse/1","type":"function"},{"doc":"","ref":"Membrane.RTSP.Response.html#t:result/0","title":"Membrane.RTSP.Response.result/0","type":"type"},{"doc":"","ref":"Membrane.RTSP.Response.html#t:t/0","title":"Membrane.RTSP.Response.t/0","type":"type"},{"doc":"This module represents an active Session.","ref":"Membrane.RTSP.Session.html","title":"Membrane.RTSP.Session","type":"module"},{"doc":"Closes open Session that was started using Session.new/4.","ref":"Membrane.RTSP.Session.html#close/2","title":"Membrane.RTSP.Session.close/2","type":"function"},{"doc":"Starts a Session under a DynamicSupervisor.","ref":"Membrane.RTSP.Session.html#new/4","title":"Membrane.RTSP.Session.new/4","type":"function"},{"doc":"Executes the request on a given session.Before execution populates with a default headers setting Session and User-Agent header. If the URI contains credentials they will also be added unless Authorization header is present in request.","ref":"Membrane.RTSP.Session.html#request/5","title":"Membrane.RTSP.Session.request/5","type":"function"},{"doc":"Start and links a Session.If an error will occur during startup, an exit signal will be sent. Session started this way can be stopped by calling Supervisor.stop/3.","ref":"Membrane.RTSP.Session.html#start_link/3","title":"Membrane.RTSP.Session.start_link/3","type":"function"},{"doc":"","ref":"Membrane.RTSP.Session.html#t:t/0","title":"Membrane.RTSP.Session.t/0","type":"type"},{"doc":"This module provides Supervisor you can start in your Supervision tree and use with Membrane.RTSP.Session.new/4.","ref":"Membrane.RTSP.Supervisor.html","title":"Membrane.RTSP.Supervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Membrane.RTSP.Supervisor.html#child_spec/1","title":"Membrane.RTSP.Supervisor.child_spec/1","type":"function"},{"doc":"","ref":"Membrane.RTSP.Supervisor.html#start_child/4","title":"Membrane.RTSP.Supervisor.start_child/4","type":"function"},{"doc":"","ref":"Membrane.RTSP.Supervisor.html#start_link/0","title":"Membrane.RTSP.Supervisor.start_link/0","type":"function"},{"doc":"This module represents the Transport contract.Struct contains module that will be used when executing request and reference used for resolving transport process.","ref":"Membrane.RTSP.Transport.html","title":"Membrane.RTSP.Transport","type":"behaviour"},{"doc":"Invoked by session process when executing requests.","ref":"Membrane.RTSP.Transport.html#c:execute/3","title":"Membrane.RTSP.Transport.execute/3","type":"callback"},{"doc":"","ref":"Membrane.RTSP.Transport.html#new/2","title":"Membrane.RTSP.Transport.new/2","type":"function"},{"doc":"Starts and links Transport process.The transport process is immediately registered in the TransportRegistry via Registry.","ref":"Membrane.RTSP.Transport.html#start_link/3","title":"Membrane.RTSP.Transport.start_link/3","type":"function"},{"doc":"","ref":"Membrane.RTSP.Transport.html#t:t/0","title":"Membrane.RTSP.Transport.t/0","type":"type"},{"doc":"","ref":"Membrane.RTSP.Transport.html#t:transport_ref/0","title":"Membrane.RTSP.Transport.transport_ref/0","type":"type"},{"doc":"This module implements the Transport behaviour and transmits requests over TCP Socket keeping connection until either session is closed or connection is closed by server.Supported options:timeout - time after request will be deemed missing and error shall be returned.","ref":"Membrane.RTSP.Transport.TCPSocket.html","title":"Membrane.RTSP.Transport.TCPSocket","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Membrane.RTSP.Transport.TCPSocket.html#child_spec/1","title":"Membrane.RTSP.Transport.TCPSocket.child_spec/1","type":"function"},{"doc":"Membrane RTSP The RTSP client for ElixirCurrently supports only RTSP 1.1 defined by RFC2326","ref":"readme.html","title":"Membrane RTSP","type":"extras"},{"doc":"The package can be installed by adding membrane_rtsp to your list of dependencies in mix.exs:def deps do [ {:membrane_rtsp, &quot;~&gt; 0.2.1&quot;} ] end","ref":"readme.html#installation","title":"Membrane RTSP - Installation","type":"extras"},{"doc":"To use Membrane RTSP client you must first start a session by calling either:alias Membrane.RTSP # It will exit if Session can&#39;t be started {:ok, session} = RTSP.Session.start_link(&quot;rtsp://domain.name:port/path&quot;) # OR # Requires you to start under Supervision tree providing Supervisor {:ok, session} = RTSP.Session.new(supervisor, &quot;rtsp://domain.name:port/path&quot;)Then you can proceed with executing requests:alias Membrane.RTSP.Response {:ok, %Response{status: 200}} = RTSP.describe(session) {:ok, %Response{status: 200}} = RTSP.setup(session, &quot;/trackID=1&quot;, [ {&quot;Transport&quot;, &quot;RTP/AVP;unicast;client_port=57614-57615&quot;} ]) {:ok, %Response{status: 200}} = RTSP.setup(session, &quot;/trackID=2&quot;, [ {&quot;Transport&quot;, &quot;RTP/AVP;unicast;client_port=52614-52615&quot;} ]) {:ok, %Response{status: 200}} = RTSP.play(session)If you started session without linking it, it is advised to close it manually by calling:RTSP.close(supervisor, session)","ref":"readme.html#usage","title":"Membrane RTSP - Usage","type":"extras"},{"doc":"To implement custom request execution logic you must implement Membrane.RTSP.Transport behavior. Then you can pass the name of your transport module to Membrane.RTSP.Session.new/4.Membrane.RTSP.Session.new/4 assumes that the transport module also implements GenServer behavior.","ref":"readme.html#implementing-custom-transport-layer","title":"Membrane RTSP - Implementing custom transport layer","type":"extras"},{"doc":"Session consists of two processes: Manager and Transport.Manager is responsible for tracking CSeq header and SessionId and Transport is responsible for transmitting the request and receiving a response. We don't want Manager to die when Transport dies and vice versa, so they are started together using Container which allows starting and stopping them as one.","ref":"readme.html#architecture","title":"Membrane RTSP - Architecture","type":"extras"},{"doc":"Tests that use external RTSP service are disabled by default but they are present in the codebase. They are tagged as external and are usually accompanied by tests that mimic their behavior by using predefined responses.","ref":"readme.html#external-tests","title":"Membrane RTSP - External tests","type":"extras"},{"doc":"Copyright 2019, Software MansionLicensed under the Apache License, Version 2.0","ref":"readme.html#copyright-and-license","title":"Membrane RTSP - Copyright and License","type":"extras"},{"doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS APPENDIX: How to apply the Apache License to your work. To apply the Apache License to your work, attach the following boilerplate notice, with the fields enclosed by brackets &quot;[]&quot; replaced with your own identifying information. (Don't include the brackets!) The text should be enclosed in the appropriate comment syntax for the file format. We also recommend that a file or class name and description of purpose be included on the same &quot;printed page&quot; as the copyright notice for easier identification within third-party archives. Copyright 2018 Software Mansion Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html","title":"LICENSE","type":"extras"}]